#ifndef G_INPUT_H
#define G_INPUT_H

#define DIRECTINPUT_VERSION 0x0500  // for joystick support

#include <dinput.h>
#include "gio.h"
//#include <mmsystem.h>

#ifdef __cplusplus
extern "C" {
#endif

struct K_Def {
  unsigned int Start, Mode;
  unsigned int A, B, C;
  unsigned int X, Y, Z;
  unsigned int Up, Down, Left, Right;
  unsigned int HotKey[4];
  unsigned int HotKey_Buttons[4];
  unsigned int Turbo;
  };

#define HKB_UP     0x0001
#define HKB_LEFT   0x0002
#define HKB_RIGHT  0x0004
#define HKB_DOWN   0x0008
#define HKB_A      0x0010
#define HKB_B      0x0020
#define HKB_C      0x0040
#define HKB_X      0x0080
#define HKB_Y      0x0100
#define HKB_Z      0x0200
#define HKB_START  0x0400
#define HKB_MODE   0x0800

extern struct K_Def Keys_Def[8];
extern unsigned char Kaillera_Keys[16];

unsigned int Get_Key(void);
int Check_Key_Pressed(int key);
int Setting_Keys(HWND hset, int Player, int Type);
int Init_Input(HINSTANCE hInst, HWND hWnd);
void End_Input(void);
void Update_Input(void);
void __stdcall Update_Controllers(void);
void Scan_Player_Net(int Player);
void Update_Controllers_Net(int num_player);

#ifdef __cplusplus
}
#endif

#endif