
#ifndef G_MAIN_H
#define G_MAIN_H

#include <windows.h>
#include "config.h"

#define GENSTITLE "Gens+"

#define X_RES   320
#define Y_RES   240

#define TIMER_ID    1
#define TIMER_RATE  30

extern HINSTANCE  ghInstance;
extern WNDCLASS   WndClass;
extern HWND       ghWnd;
extern const char gWndTitle[];

extern int Active;
extern int Paused;
extern int Net_Play;
extern int Show_FPS;
extern int Show_Message;
extern int Language;
extern int Country;
extern int Country_Order[3];
extern int WinNT_Flag;
extern int Gens_Priority;
extern int Kaillera_Client_Running;
extern int SegaCD_Accurate;
extern int Gens_Running;
extern int Turbo_Mode;
extern int Turbo_Speed;

extern POINT Window_Pos;

extern char Str_Tmp      [1024];
extern char Gens_Dir     [GMAX_PATH + 4];
extern char Language_Path[GMAX_PATH + 4];

void __fastcall Set_Title(LPCSTR, LPCSTR);
int  __stdcall  Set_Render(HWND hWnd, int Full, int Device, int Num, int Force);
int  __fastcall Change_Sound(HWND hWnd);
int  __stdcall  Build_Language_String(void);
void __fastcall Center_Dialog(HWND hDlg);

extern LPSTR *language_name;

#define LANGUAGE_STRING(str, def, buf, buf_size) \
  GetPrivateProfileString(language_name[Language], str, def, buf, buf_size, Language_Path);

#define WM_KNUX        (WM_USER + 3)
#define GENS_VERSION_H ((GENSVER2 << 16) | GENSVER1)

#define MINIMIZE                              \
if (Sound_Initialised) Clear_Sound_Buffer();  \
if (Full_Screen)                              \
{                                             \
  Set_Render(hWnd, 0, -1, -1, TRUE);          \
  FS_Minimised = 1;                           \
}

#define WORD_L(id, str, suffixe, def) \
GetPrivateProfileString(language_name[Language], (str), (def), Str_Tmp, 1024, Language_Path);  \
strcat(Str_Tmp, (suffixe)); \
SetDlgItemText(hDlg, id, Str_Tmp);

#define MESSAGE_L(str, def, time)                                  \
{                                                  \
  GetPrivateProfileString(language_name[Language], (str), (def), Str_Tmp, 1024, Language_Path);  \
  Put_Info(Str_Tmp, (time));                                    \
}

#define MESSAGE_NUM_L(str, def, num, time)                              \
{                                                  \
  char mes_tmp[1024];                                        \
  GetPrivateProfileString(language_name[Language], (str), (def), Str_Tmp, 1024, Language_Path);  \
  sprintf(mes_tmp, Str_Tmp, (num));                                \
  Put_Info(mes_tmp, (time));                                    \
}

#define TITLE_L(str, def) \
GetPrivateProfileString(language_name[Language], (str), (def), Str_Tmp, 1024, Language_Path);  \
SetWindowText(hDlg, Str_Tmp);

#endif