/* GSR.cpp - projeto gens+. Rodrigo Cardoso.
   Loga arquivos GSR. O formato VGM fica muito grande para genesis, estou tentando criar
   um formato que fique menor. */

#ifndef _GSR_H
#define _GSR_H

#include "gmain.h"
#include "grom.h"
#include "ym2612.h"
#include "psg.h"

#ifdef __cplusplus
extern "C" {
#endif

#define GSR_TYPE    0x00525347
#define GSR_VERSION MAKELONG(1, 0)

// cabealho do arquivo, deve vir logo no incio
typedef struct tagGSRHEADER {
  DWORD            dwType;         // deve ser GSR_TYPE
  DWORD            dwVersion;      // deve ser GSR_VERSION
  DWORD            dwExtraHdr;     // tamanho de algum dado extra depois desta estrutura
  DWORD            dwTableSamples; // nmero de samples na tabela
  DWORD            dwTotalLength;  // nmero total de samples
  DWORD            dwOffsetLoop;   // distncia at o loop (0 se no houver loop)
  DWORD            dwLoopLength;   // tamanho do loop (0 se no houver loop)
  DWORD            dwLoopTimes;    // nmero de vezes que o loop deve ser repetido
  DWORD            dwFade;         // tempo de silncio decorrido at o incio do som
  DWORD            dwFlags;        // flags
  DWORD            dwReserved1;    // reservado para verses futuras
  DWORD            dwReserved2;    // reservado para verses futuras
  GENESIS_ROM_INFO griRomInfo;     // dados sobre a rom de onde o som foi extrado
} GSRHEADER, *PGSRHEADER, *LPGSRHEADER;

// flags vlidos
#define GSR_FLAG_PAL_SYSTEM   0x01  // o arquivo foi gravado usando PAL ao invs de NTSC

// aps o cabealho, segue esta estrutura que possui o estado inicial dos chips
typedef struct tagCHIPSINFO {
  BYTE             YM2612_Reg[0x200];       // YM2612
  int              PSG_Reg[8];              // PSG
} CHIPSINFO, *PCHIPSINFO, *LPCHIPSINFO;


void __stdcall Start_GSR_Dump(void);
void __stdcall Stop_GSR_Dump(void);
void __stdcall Update_GSR_Dump(int, int, int);

// comandos vlidos
#define GSRDUMP_FRAME_END       0x00
#define GSRDUMP_YM2612_PORT1    0x01
#define GSRDUMP_YM2612_PORT2    0x02
#define GSRDUMP_PSG             0x03
#define GSRDUMP_CHANGE_VDP_LINE 0x04

extern int GSR_Dumping;

#ifdef __cplusplus
}
#endif

#endif // _GSR_H
